﻿using System;
using System.Collections.Generic;

namespace BitMaskTest
{
    /*
	 * AND &: 비트가 모두 1일 때 1 반환
	 * 1011 & 1001 = 1001
	 * 
	 * OR |: 비트가 하나라도 1일 때 1 반환
	 * 1011 | 1001 = 1011
	 * 
	 * XOR ^: 비트가 같지 않을 때 1 반환
	 * 1011 ^ 1001 = 0010
	 * 
	 * NOT ~: 비트 반전
	 * ~1011 = 0100
	 * 
	 * Shift << >>: 비트를 옮기는 연산
	 * 001011 << 2 = 101100
	 * 001011 >> 2 = 000010
	 */
    class Program
    {
        static void Main(string[] args)
        {
            PopupButtonMask popupButton = new PopupButtonMask();
            popupButton.Mask = ButtonMask.LevelUp | ButtonMask.Cancel | ButtonMask.Remove | ButtonMask.Change;

            System.Console.WriteLine(popupButton.checkMask(ButtonMask.All));

            // List<ButtonMask> buttons = popupButton.GetButtons();
            // foreach (ButtonMask item in buttons)
            // {
            //     Console.WriteLine(item);
            // }
        }
    }
}
